
    #include"nec_helper.h"
	
	// ------------------ -   ------------------------
	 
	unsigned char colour_dat(unsigned char col)
	{
	unsigned char bb=0;
	switch(col)  //   ,    
		{                                                                               
		case  0: bb=0x68; break;  // B4  
		case  1: bb=0x20; break;  // R0
		case  2: bb=0x10; break;  // R1
		case  3: bb=0x30; break;  // R2
		case  4: bb=0xA0; break;  // G0
		case  5: bb=0x90; break;  // G1
		case  6: bb=0xB0; break;  // G2
		case  7: bb=0x88; break;  // G3
		case  8: bb=0x60; break;  // B0
		case  9: bb=0x50; break;  // B1
		case 10: bb=0x70; break;  // B2
		case 11: bb=0x48;         // B3
		}
	return (bb); //  	
	}
	 
	// ------------------ -    -----------------
	 
	void ind_led(unsigned char ty)
	{
	for(unsigned char ind=0; ind < ty; ind++)  
		{
		  PORTD |= _BV(IND);
		  _delay_ms(100);
	      PORTD &= ~_BV(IND);
		  _delay_ms(300);
	    }
    }
	 
	// ------------------ -   38000 Hz ---------------------------
	void FreqOn (void) 
	{
	  TCCR0A |= (1<<COM0A0)|(0<<COM0A1)|(0<<COM0B0)|(0<<COM0B1)	//    
	  |(0<<WGM00)|(1<<WGM01); 			                        // CTC (  )
	  
	  TCCR0B |=(1<<FOC0A)|(0<<FOC0B)         //     
	  |(1<<CS00)|(0<<CS01)|(0<<CS02);        //    
	  
	  TCNT0 = 0;
	  
	  //   (38000 Hz *2=72000 Hz) .        
	  // 12000000 / 76000= 156
	  // OCR0A =156 -1  = 0x9C   
		
	  OCR0A = 0x9D;   //    
	}
      	
	// --------------- -   38000 Hz -------------------------------------
	 
	void FreqOff (void) 
	{
	  TCCR0B = 0;					//  38000 Hz
      PORTB &= ~_BV(PB2);           //      
	} 
	 
	//------------------- -     IR -----------------------------
	  
	//byte -  
	void TransmitByte (char byte)
	{
	for(char i=0; i<8; i++)
		{
		  FreqOn ();					//  38000
		  _delay_us (600);				// 0,66 
          
		  FreqOff ();					//  38000
		if(byte & 0x80)				    //
				_delay_us (1640);		//  = 1  1,58 
		else
				_delay_us (520);		//  = 0  0,46 
	     
		  byte <<= 1;					// 
		}
	}
	 
	  // "0"       460 + 660 = 1120 us
	  // "1"      1580 + 660 = 2240 us
	  //       
	
	  //  ,    600 us
	  //  "0"  1120-600= 520 us 
	  //      "1"  2240-600=1640 us
	 
	// ------------------ -   -----------------------
	 
	void reset(void)
	{
	  PORTD &= ~_BV(PD2);
	  PORTD &= ~_BV(PD3);
	  PORTD &= ~_BV(PD4); 
	  PORTD &= ~_BV(PD5);
	}
       
	// ------------------ -  ------------
	  
	void mult_dat(unsigned char devices)
	{
	if(devices == 0)
		{
	      PORTD |=  _BV(PD2);
		  PORTD &= ~_BV(PD3);
		  PORTD &= ~_BV(PD4); 
		  PORTD &= ~_BV(PD5); 
	    }
		 
	if(devices == 1)
		{
	      PORTD &= ~_BV(PD2);
		  PORTD |=  _BV(PD3);
		  PORTD &= ~_BV(PD4);
          PORTD &= ~_BV(PD5); 
	    }
		 
	if(devices == 2)
		{
	      PORTD &= ~_BV(PD2);
		  PORTD &= ~_BV(PD3);
		  PORTD |=  _BV(PD4); 
		  PORTD &= ~_BV(PD5); 
	    }
		 
	if(devices == 3)
		{
	      PORTD &= ~_BV(PD2);
		  PORTD &= ~_BV(PD3);
		  PORTD &= ~_BV(PD4); 
		  PORTD |=  _BV(PD5);
	    }
	}
	  
	// ---------------- -     IR ------------------------------
	  
	  //dev -  
	  //command -  
	void TransmitCmnd (unsigned char dev,unsigned char command)
	{ 
	   mult_dat(dev);
	 
	  // 
	  FreqOn ();						//  38000
	  _delay_ms (9);					// 9 
	 
	  FreqOff ();							//  38000
	  _delay_us (4400);					// 4,4 
      
	  // 
	  TransmitByte (0x00);				//  
	  TransmitByte (0xF7);				//  
	  TransmitByte (command);			// 
	  TransmitByte (~command);			// 
     
	  // 
	  FreqOn ();						//  38000
	  _delay_us (660);					// 0,66 
       
	  FreqOff ();						//  38000
	  
	  reset();
	}
	 
	// ---------------- -      IR ------------------------------
	
	void TransmitBloc(unsigned char a,unsigned char b,unsigned char c,unsigned char d,unsigned char trem)
	{
	unsigned char cm=0;
	for(unsigned char mn=0; mn < trem; mn++)   //      
		{
		for(unsigned char gk=0; gk < 4; gk++)   //  
			{
			if(gk==0) cm=a;
			if(gk==1) cm=b;
			if(gk==2) cm=c;
			if(gk==3) cm=d;
			
			  TransmitCmnd(gk,cm);
			}
		}
    }
	
	
	
	
	
	
     